﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Contrib.SmsUslugi.Models;
using Orchard.ContentManagement;
using Orchard.ContentManagement.Drivers;
using Orchard.Localization;

namespace Contrib.SmsUslugi.Drivers
{
    public class SmsuslugiSettingsPartDriver  : ContentPartDriver<SmsuslugiSettingsPart>
    {
        private const string TemplateName = "Parts/SmsuslugiSettings";
        public Localizer T { get; set; }

        public SmsuslugiSettingsPartDriver()
        {
            T = NullLocalizer.Instance;
        }

        protected override string Prefix { get { return "SmsuslugiSettings"; } }

        protected override DriverResult Editor(SmsuslugiSettingsPart part, dynamic shapeHelper)
        {
            return ContentShape("Parts_SmsuslugiSettings_Edit",
                    () => shapeHelper.EditorTemplate(TemplateName: TemplateName, Model: part, Prefix: Prefix))
                    .OnGroup("SMS");
        }

        protected override DriverResult Editor(SmsuslugiSettingsPart part, IUpdateModel updater, dynamic shapeHelper)
        {
            return ContentShape("Parts_SmsuslugiSettings_Edit", () =>
            {
                var previousAuthToken = part.Password;
                updater.TryUpdateModel(part, Prefix, null, null);

                // restore password if the input is empty, meaning it has not been reseted
                if (string.IsNullOrEmpty(part.Password))
                {
                    part.Password = previousAuthToken;
                }
                return shapeHelper.EditorTemplate(TemplateName: TemplateName, Model: part, Prefix: Prefix);
            }).OnGroup("SMS");
        }
    }
}