﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Orchard.ContentManagement;
using Orchard.ContentManagement.Utilities;

namespace Contrib.SmsUslugi.Models
{
    public class SmsuslugiSettingsPart : ContentPart<SmsuslugiSettingsPartRecord>
    {
        private readonly ComputedField<string> authToken = new ComputedField<string>();

        public ComputedField<string> AuthTokenField
        {
            get { return authToken; }
        }

        public string Login
        {
            get { return Record.Login; }
            set { Record.Login = value; }
        }

        public string Password
        {
            get { return Record.Password; }
            set { Record.Password = value; }
        }
        public string SenderTag
        {
            get { return Record.SenderTag; }
            set { Record.SenderTag = value; }
        }
         
        public bool IsValid()
        {
            return !String.IsNullOrWhiteSpace(Record.Login)
                && !String.IsNullOrWhiteSpace(Record.Password)
                 && !String.IsNullOrWhiteSpace(Record.SenderTag);
        }
    }
}