﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Contrib.SmsUslugi.Models;
using Orchard;
using Orchard.ContentManagement;
using Orchard.Localization;
using Orchard.UI.Admin.Notification;
using Orchard.UI.Notify;

namespace Contrib.SmsUslugi.Service
{
    public class MissingSettingsSmsUslugi : INotificationProvider
    {
        private readonly IOrchardServices orchardServices;
        public Localizer T { get; set; }

        public MissingSettingsSmsUslugi(IOrchardServices orchardServices)
        {
            this.orchardServices = orchardServices;
            T = NullLocalizer.Instance;
        }

        public IEnumerable<NotifyEntry> GetNotifications()
        {
            var workContext = orchardServices.WorkContext;
            var smsSettings = workContext.CurrentSite.As<SmsuslugiSettingsPart>();

            if (smsSettings == null || !smsSettings.IsValid())
            {
                var urlHelper = new UrlHelper(workContext.HttpContext.Request.RequestContext);
                var url = urlHelper.Action("Sms", "Admin", new { Area = "Settings" });
                yield return new NotifyEntry { Message = T("The <a href=\"{0}\">SMS settings</a> needs to be configured.", url), Type = NotifyType.Warning };
            }
        }
    }
}